class Piece {
  constructor(color, type) {
    this.color = color;
    this.type = type;
    this.passantable = false;
    this.moves = 0;
  }

  setType(type) {
    this.type = type;
  }

  getInfoText() {
    if(this.moves === 1) {
      return "Has made 1 move"
    } else {
      return "Has made " + this.moves + " moves"
    }
  }

  isEmpty() {
    return this.type === EMPTY;
  }

  isFull() {
    return !this.isEmpty();
  }

  isBlack() {
    return this.color === BLACK;
  }

  isWhite() {
    return this.color === WHITE;
  }

  isEnemyOf(piece) {
    if (this.color === EMPTY || piece.color === EMPTY) {
      return false;
    } else {
      return this.color !== piece.color;
    }
  }

  isFriendOf(piece) {
    if (this.color === EMPTY || piece.color === EMPTY) {
      return false;
    } else {
      return this.color === piece.color;
    }
  }

  is(type) {
    return this.type === type;
  }

  hasMoved() {
    return this.moves !== 0;
  }

  hasNotMoved() {
    return !this.hasMoved();
  }
}

export { Piece }